unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, dxCore,
  ActiveX;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_WJGMDList, U_WJGCKOutList, U_WJGCKKCList, U_DJBRKList,
  U_DJBCKOutList, U_DJBCKKCList, U_DJBCKKCHZList, U_WJGCKKCHZList, U_SXCKNewList,
  U_SXCKOutList, U_PBCKKCList, U_CPBRKList, U_CPBCKKCList, U_CPBCKOutList,
  U_DJBHCHZList, U_WJTJList, U_CPCKOutList;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////

var
  frmCPBCKOutListSQ, frmCPBCKOutListQR: TfrmCPBCKOutList;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);

  server := '47.100.130.130,7781';
//  server := '.';
  dtbase := 'zhenyongdata';
  user := 'zhenyongsa';
  pswd := 'rightsoft@9101';
//  pswd := 'rightsoft';
  DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
  DConString := DataBaseStr;
 // DName:='周高祥';
//   DParameters1:='高权限';
//   DParameters3:='1';
  if not ConnData() then
  begin
    result := 0;
    exit;
  end;

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of
    1:  //外检数据统计
      begin
        if frmWJTJList = nil then
        begin
          frmWJTJList := TfrmWJTJList.Create(application.MainForm);
          with frmWJTJList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmWJTJList.BringToFront;
       //句柄
        mnewHandle := frmWJTJList.Handle;
      end;

    111:  //坯布入库
      begin
        if frmSXCKNewList = nil then
        begin
          frmSXCKNewList := TfrmSXCKNewList.Create(application.MainForm);
          with frmSXCKNewList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmSXCKNewList.BringToFront;
       //句柄
        mnewHandle := frmSXCKNewList.Handle;
      end;
    121:  //坯布出库
      begin
        if frmSXCKOutList = nil then
        begin
          frmSXCKOutList := TfrmSXCKOutList.Create(application.MainForm);
          with frmSXCKOutList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmSXCKOutList.BringToFront;
       //句柄
        mnewHandle := frmSXCKOutList.Handle;
      end;
    131:  //坯布库存
      begin
        if frmPBCKKCList = nil then
        begin
          frmPBCKKCList := TfrmPBCKKCList.Create(application.MainForm);
          with frmPBCKKCList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmPBCKKCList.BringToFront;
       //句柄
        mnewHandle := frmPBCKKCList.Handle;
      end;
    211:  //外加工入库
      begin
        if frmWJGMDList = nil then
        begin
          frmWJGMDList := TfrmWJGMDList.Create(application.MainForm);
          with frmWJGMDList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmWJGMDList.BringToFront;
       //句柄
        mnewHandle := frmWJGMDList.Handle;
      end;
    221:  //外加工出库
      begin
        if frmWJGCKOutList = nil then
        begin
          frmWJGCKOutList := TfrmWJGCKOutList.Create(application.MainForm);
          with frmWJGCKOutList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmWJGCKOutList.BringToFront;
       //句柄
        mnewHandle := frmWJGCKOutList.Handle;
      end;
    231:  //外加工库存
      begin
        if frmWJGCKKCList = nil then
        begin
          frmWJGCKKCList := TfrmWJGCKKCList.Create(application.MainForm);
          with frmWJGCKKCList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmWJGCKKCList.BringToFront;
       //句柄
        mnewHandle := frmWJGCKKCList.Handle;
      end;

    232:  //外加工库存汇总
      begin
        if frmWJGCKKCHZList = nil then
        begin
          frmWJGCKKCHZList := TfrmWJGCKKCHZList.Create(application.MainForm);
          with frmWJGCKKCHZList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmWJGCKKCHZList.BringToFront;
       //句柄
        mnewHandle := frmWJGCKKCHZList.Handle;
      end;

    341:  //待检布回仓统计
      begin
        if frmDJBHCHZList = nil then
        begin
          frmDJBHCHZList := TfrmDJBHCHZList.Create(application.MainForm);
          with frmDJBHCHZList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmDJBHCHZList.BringToFront;
       //句柄
        mnewHandle := frmDJBHCHZList.Handle;
      end;
    311:  //待检布入库列表
      begin
        if frmDJBRKList = nil then
        begin
          frmDJBRKList := TfrmDJBRKList.Create(application.MainForm);
          with frmDJBRKList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmDJBRKList.BringToFront;
       //句柄
        mnewHandle := frmDJBRKList.Handle;
      end;
    321:  //待检布出库列表
      begin
        if frmDJBCKOutList = nil then
        begin
          frmDJBCKOutList := TfrmDJBCKOutList.Create(application.MainForm);
          with frmDJBCKOutList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmDJBCKOutList.BringToFront;
       //句柄
        mnewHandle := frmDJBCKOutList.Handle;
      end;
    322:  //次品出库列表
      begin
        if frmcpCKOutList = nil then
        begin
          frmcpCKOutList := TfrmcpCKOutList.Create(application.MainForm);
          with frmcpCKOutList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmcpCKOutList.BringToFront;
       //句柄
        mnewHandle := frmcpCKOutList.Handle;
      end;
    331:  //待检布库存列表
      begin
        if frmDJBCKKCList = nil then
        begin
          frmDJBCKKCList := TfrmDJBCKKCList.Create(application.MainForm);
          with frmDJBCKKCList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmDJBCKKCList.BringToFront;
       //句柄
        mnewHandle := frmDJBCKKCList.Handle;
      end;
    332:  //待检布汇总库存列表
      begin
        if frmDJBCKKCHZList = nil then
        begin
          frmDJBCKKCHZList := TfrmDJBCKKCHZList.Create(application.MainForm);
          with frmDJBCKKCHZList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmDJBCKKCHZList.BringToFront;
       //句柄
        mnewHandle := frmDJBCKKCHZList.Handle;
      end;

    411:  //直销布入库列表
      begin
        if frmCPBRKList = nil then
        begin
          frmCPBRKList := TfrmCPBRKList.Create(application.MainForm);
          with frmCPBRKList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPBRKList.BringToFront;
       //句柄
        mnewHandle := frmCPBRKList.Handle;
      end;
    441:  //直销布出库申请
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '直销布出库申请 ' then
          begin
            BringWindowToTop(frmCPBCKOutListSQ.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCPBCKOutListSQ := TfrmCPBCKOutList.Create(application.MainForm);
          with frmCPBCKOutListSQ do
          begin
            Title := '直销布出库申请 ';
            caption := Trim(Title);
            canshu1 := '申请录入';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPBCKOutListSQ.BringToFront;
       //句柄
        mnewHandle := frmCPBCKOutListSQ.Handle;
      end;
    421:  //直销布出库确认
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '直销布出库确认 ' then
          begin
            BringWindowToTop(frmCPBCKOutListQR.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmCPBCKOutListQR := TfrmCPBCKOutList.Create(application.MainForm);
          with frmCPBCKOutListQR do
          begin
            Title := '直销布出库确认 ';
            caption := Trim(Title);
            canshu1 := '出库确认';
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPBCKOutListQR.BringToFront;
       //句柄
        mnewHandle := frmCPBCKOutListQR.Handle;
      end;

    431:  //直销布库存列表
      begin
        if frmCPBCKKCList = nil then
        begin
          frmCPBCKKCList := TfrmCPBCKKCList.Create(application.MainForm);
          with frmCPBCKKCList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPBCKKCList.BringToFront;
       //句柄
        mnewHandle := frmCPBCKKCList.Handle;
      end;
  end;

  Result := mnewHandle;
end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
begin
  if not Assigned(DataLink_PBMDDJ) then
    DataLink_PBMDDJ := TDataLink_PBMDDJ.Create(Application);
  try
    with DataLink_PBMDDJ.ADOLink do
    begin
      //if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_PBMDDJ.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

